'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var array = function array(inputType) {
  var opts = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var InputWrapper = function InputWrapper(_ref) {
    var value = _ref.value;
    var onChange = _ref.onChange;
    var children = _ref.children;
    return _react2.default.createElement(
      ArrayInput,
      { value: value, onChange: onChange, InputType: inputType, opts: opts },
      children
    );
  };
  InputWrapper.defaultValue = [];
  return InputWrapper;
};

var ArrayInput = function ArrayInput(_ref2) {
  var _ref2$value = _ref2.value;
  var value = _ref2$value === undefined ? [] : _ref2$value;
  var _onChange = _ref2.onChange;
  var InputType = _ref2.InputType;
  var opts = _ref2.opts;
  var children = _ref2.children;
  return _react2.default.createElement(
    'label',
    null,
    opts.label,
    _react2.default.createElement(
      'ul',
      null,
      value.map(function (item, idx) {
        return _react2.default.createElement(
          'li',
          { key: 'item-' + idx },
          _react2.default.createElement(
            InputType,
            {
              value: item,
              onChange: function onChange(val) {
                return _onChange(changeItem(value, idx, val));
              } },
            _react2.default.createElement(
              'span',
              { onClick: function onClick() {
                  return _onChange(removeItem(value, idx));
                } },
              '×'
            )
          )
        );
      }),
      _react2.default.createElement(
        'li',
        { onClick: function onClick() {
            return _onChange(value.concat(InputType.defaultValue));
          } },
        'Add',
        ' ' + opts.label
      )
    ),
    children
  );
};

var changeItem = function changeItem(arr, idx, val) {
  var newArr = (0, _lodash.merge)([], arr);
  newArr[idx] = val;
  return newArr;
};

var removeItem = function removeItem(arr, idx) {
  var newArr = (0, _lodash.merge)([], arr);
  newArr.splice(idx, 1);
  return newArr;
};

exports.default = array;