'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var object = function object(inputTypes) {
  var opts = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var InputWrapper = function InputWrapper(_ref) {
    var value = _ref.value;
    var onChange = _ref.onChange;
    var children = _ref.children;
    return _react2.default.createElement(
      ObjectInput,
      { onChange: onChange, value: value, inputTypes: inputTypes, opts: opts },
      children
    );
  };
  var defaultValue = {};
  Object.keys(inputTypes).forEach(function (key) {
    defaultValue[key] = inputTypes[key].defaultValue;
  });
  InputWrapper.defaultValue = defaultValue;
  return InputWrapper;
};

var ObjectInput = function ObjectInput(_ref2) {
  var _ref2$value = _ref2.value;
  var value = _ref2$value === undefined ? {} : _ref2$value;
  var _onChange = _ref2.onChange;
  var inputTypes = _ref2.inputTypes;
  var opts = _ref2.opts;
  var children = _ref2.children;
  return _react2.default.createElement(
    'label',
    null,
    opts.label,
    children,
    Object.keys(inputTypes).map(function (key) {
      var Input = inputTypes[key];
      return _react2.default.createElement(Input, {
        key: 'input' + key,
        value: value[key],
        onChange: function onChange(val) {
          return _onChange(Object.assign({}, value, _defineProperty({}, key, val)));
        } });
    })
  );
};

exports.default = object;