"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _ = require("../");

var InputTypes = _interopRequireWildcard(_);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var fromObject = function fromObject(obj, opts) {
  var inputs = {};
  Object.keys(obj).forEach(function (key) {
    var val = obj[key];
    inputs[key] = getInputType(val, { label: labelFromKey(key) }, key);
  });
  return InputTypes.object(inputs, opts);
};

var getInputType = function getInputType(val, opts, key) {
  switch (typeof val === "undefined" ? "undefined" : _typeof(val)) {
    case "object":
      if (Array.isArray(val)) {
        return InputTypes.array(getInputType(val[0]), opts);
      } else {
        return fromObject(val);
      }
    case "string":
      if (key === 'password') {
        return InputTypes.password(opts);
      } else if (val.length > 30) {
        return InputTypes.text(opts);
      } else {
        return InputTypes.string(opts);
      }
    default:
      return InputTypes[typeof val === "undefined" ? "undefined" : _typeof(val)](opts) || InputTypes.string(opts);
  }
};

var labelFromKey = function labelFromKey(label) {
  return label.replace(/([A-Z])/g, ' $1').replace(/^./, function (str) {
    return str.toUpperCase();
  });
};

exports.default = fromObject;